// JustInTime.cpp : Implementation of CJustInTime
#include "stdafx.h"
#include "Asp1401.h"
#include "JustInTime.h"

/////////////////////////////////////////////////////////////////////////////
// CJustInTime
HRESULT CJustInTime::Activate()
{
   HRESULT hr;
   CComVariant vt;
   CComBSTR bstrProp;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
   hr = GetObjectContext(&m_spObjectContext);
	hr = CoGetObjectContext(IID_IObjectContext, (void **)&m_spObjectContext);
   if (FAILED(hr)) return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) return hr;

   // get Response 
   bstrProp = "Response";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   // get Application 
   bstrProp = "Application";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IApplicationObject, 
                     (void**)&m_piApplication );

   // get Session 
   bstrProp = "Session";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_ISessionObject, 
                     (void**)&m_piSession );

   // get Request
   bstrProp = "Request";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IRequest, 
                     (void**)&m_piRequest );

   // get Server
   bstrProp = "Server";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IServer, 
                     (void**)&m_piServer );

	return hr;
} 

BOOL CJustInTime::CanBePooled()
{
	return FALSE;
} 

void CJustInTime::Deactivate()
{
   m_piServer.Release();
   m_piSession.Release();
   m_piRequest.Release();
   m_piResponse.Release();
	m_piApplication.Release();
	m_spObjectContext.Release();
} 



STDMETHODIMP CJustInTime::sayHello(BSTR bstrName)
{
    CComBSTR bstrMessage = "Hello ";
    bstrMessage.Append(bstrName);

    m_piResponse->Write(_variant_t(bstrMessage.Detach()));

	return S_OK;
}

STDMETHODIMP CJustInTime::setCacheDate(int iYear, int iMonth, int iDay)
{
   HRESULT hr; 
   SYSTEMTIME st;
   double dtTime;

   // initialize memory
   ZeroMemory (&st, sizeof(st)) ;

   // set date
   st.wYear = iYear;
   st.wMonth = iMonth;
   st.wDay = iDay;

   // set time
   st.wHour = 13;
   st.wMinute = 13;

   SystemTimeToVariantTime(&st,&dtTime);
 
   hr=m_piResponse->put_ExpiresAbsolute(dtTime);

   return hr;
}


STDMETHODIMP CJustInTime::getContentValue(BSTR bstrName)
{
   HRESULT hr = S_OK;
   _variant_t vtValue;

   // get specific item
   hr = m_piApplication->get_Value(bstrName, &vtValue);
   if (FAILED(hr)) return hr;

      // write value out
   m_piResponse->Write(vtValue);
   m_piResponse->Write(_variant_t("<p>"));


   // Get the Contents Collection
   IVariantDictionary* piVariantVariables;
   hr = m_piApplication->get_Contents(&piVariantVariables);
   if (FAILED(hr)) return hr;

   // Get the item from the Contents collection
   hr = piVariantVariables->get_Item(_variant_t(bstrName),&vtValue);
   if (FAILED(hr)) return hr;

   // write value out
   m_piResponse->Write(vtValue);
   m_piResponse->Write(_variant_t("<p>"));

   // remove the item
   piVariantVariables->Remove(_variant_t(bstrName));

   return S_OK;
}

STDMETHODIMP CJustInTime::listContents()
{
   HRESULT hr;
	IEnumVARIANT* piEnum;
   IUnknown* piUnk;
   IVariantDictionary* piVariant;

   hr = m_piSession->get_Contents(&piVariant);
   if (FAILED(hr)) return hr;

   hr = piVariant->get__NewEnum(&piUnk);
   if (FAILED(hr)) return hr;

   hr = piUnk->QueryInterface(IID_IEnumVARIANT, (void **)&piEnum);
   if (FAILED(hr)) return hr;

   piUnk->Release();

   _variant_t vtItem, vtValue;
   while (S_OK == piEnum->Next(1,&vtItem,NULL)) {
      
      m_piResponse->Write(vtItem);
      m_piResponse->Write(_variant_t("="));

      // get value
      m_piSession->get_Value(_bstr_t(vtItem), &vtValue);
      m_piResponse->Write(vtValue);
      m_piResponse->Write(variant_t("<p>"));
   }

   piEnum->Release();

	return S_OK;
}

STDMETHODIMP CJustInTime::showVariables()
{
   HRESULT hr;
	IEnumVARIANT* piEnum;
   IUnknown* piUnk;
   IRequestDictionary* piDict;
   ULONG lValue;

   // get Server Variables
   hr = m_piRequest->get_ServerVariables(&piDict);
   if (FAILED(hr)) return hr;

   // get enumerator
   hr = piDict->get__NewEnum(&piUnk);
   if (FAILED(hr)) return hr;

   hr = piUnk->QueryInterface(IID_IEnumVARIANT, (void **)&piEnum);
   if (FAILED(hr)) return hr;

   // enumerate through collection, printing out values
   _variant_t vtItem, vtValue;
   while (S_OK == piEnum->Next(1,&vtItem,&lValue)) {
      
      m_piResponse->Write(vtItem);
      m_piResponse->Write(_variant_t("="));

      // get value
      piDict->get_Item(vtItem, &vtValue);
      m_piResponse->Write(vtValue);
      m_piResponse->Write(variant_t("<br>"));
   }

   // cleanup
   piEnum->Release(); 
   piUnk->Release();

   return S_OK;

}

STDMETHODIMP CJustInTime::encodeValues(BSTR bstrHTML, BSTR bstrURL, 
                                       BSTR bstrPath, BSTR bstrMap)
{
   _variant_t vtOut;
   CComBSTR bstrOut;
   _variant_t vtSeparator = "<p>";

   // HTML Encoding
   m_piServer->HTMLEncode(bstrHTML, &bstrOut);
   vtOut = bstrOut;
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // URL Encoding
   m_piServer->URLEncode(bstrURL, &bstrOut);
   vtOut = bstrOut;
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // path encoding
   m_piServer->URLPathEncode(bstrPath, &bstrOut);
   vtOut = bstrOut;
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtSeparator);

   // path mapping
   m_piServer->MapPath(bstrMap, &bstrOut);
   vtOut = bstrOut;
   m_piResponse->Write(vtOut);


	return S_OK;
}
