// connection.cpp : Implementation of Cconnection
#include "stdafx.h"
#include "Asp1501.h"
#include "connection.h"

#import "C:\Program Files\Common Files\System\ADO\msado15.dll" \
    no_namespace rename("EOF", "EndOfFile")

/////////////////////////////////////////////////////////////////////////////
// Cconnection

HRESULT Cconnection::Activate()
{
   HRESULT hr = S_OK;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
	hr = CoGetObjectContext(IID_IObjectContext, (void **)&m_spObjectContext);
    
   if (FAILED(hr)) return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) return hr;

   // get Response property
   hr = pProps->GetProperty( _bstr_t("Response"), &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );
   if (FAILED(hr)) return hr;

   // get connection string
   CComPtr<IApplicationObject> pApplication;

   hr = pProps->GetProperty(_bstr_t("Application"),&vt);
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IApplicationObject, 
                     (void**)&pApplication );
   if (FAILED(hr)) return hr;
  
   CComVariant vtConn;
   CComBSTR bstrName("connection");
   hr = pApplication->get_Value(bstrName,&vtConn);
   
   if (FAILED(hr)) return hr;

   m_bstrConnection = vtConn;

   return S_OK;
} 

BOOL Cconnection::CanBePooled()
{
	return TRUE;
} 

void Cconnection::Deactivate()
{
    m_piResponse.Release();
	m_spObjectContext.Release();
} 

// print out contents 
// or Connection's Properties collection
STDMETHODIMP Cconnection::showProperties()
{
  _ConnectionPtr pConnection = NULL;
  PropertiesPtr props;
  PropertyPtr prop;
  _bstr_t bstrName;
  _variant_t varValue;

  try {
    pConnection.CreateInstance(__uuidof(Connection));

    // open connection
    pConnection->PutConnectionString(m_bstrConnection);
    pConnection->Open("","","",NULL);

    // get properties and print out values
    props = pConnection->GetProperties();
    long ct;
    ct=props->GetCount();
    for (long l = 0; l < ct; l++) {

        // get Property
        prop =props->GetItem(l);
        bstrName = prop->GetName();
        varValue = prop->GetValue();

        // write out values
        m_piResponse->Write(_variant_t(bstrName + L" = "));
        m_piResponse->Write(varValue);
        m_piResponse->Write(variant_t("<br>"));
    }

    // close connection
    pConnection->Close();

  }

  // exception handling
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;
}

STDMETHODIMP Cconnection::showColumns()
{
  _ConnectionPtr pConnection = NULL;
  _RecordsetPtr pRecs;

  _bstr_t bstrName;
  _variant_t varValue;

  try {

    // open connection
    pConnection.CreateInstance(__uuidof(Connection));
    pConnection->PutProvider(L"SQLOLEDB");
    pConnection->PutConnectionString(m_bstrConnection);
    pConnection->Open("","","",NULL);

    SAFEARRAY FAR* psa = NULL;
    SAFEARRAYBOUND rgsabound;
    _variant_t  var;
    _variant_t Array;

    // create safearray
    rgsabound.lLbound = 0;
    rgsabound.cElements = 4;
    psa = SafeArrayCreate(VT_VARIANT, 1, &rgsabound);
    
    // add array items
    var.vt = VT_EMPTY;
    long ix;
    ix = 1;
    SafeArrayPutElement(psa, &ix, &var);
    ix= 2;
    SafeArrayPutElement(psa, &ix, &var);
    ix = 3;
    SafeArrayPutElement(psa, &ix, &var);
    ix= 0;
    var.vt = VT_BSTR;
    char * s1 = "weaver";
    _bstr_t str = s1;
    var.bstrVal=str;
    SafeArrayPutElement(psa, &ix, &var);
    Array.vt = VT_ARRAY|VT_VARIANT;
    Array.parray = psa;  
        
    // get records
    _variant_t table_name;
    _variant_t curr_table = "";
    _variant_t column_name;
    _variant_t data_type;
    pRecs = pConnection->OpenSchema(adSchemaColumns,&Array);

    // setup output table
    m_piResponse->Write(_variant_t("<table border=2>"));
    while(!(pRecs->EndOfFile)) {

        // get values
        table_name = pRecs->Fields->GetItem("TABLE_NAME")->GetValue();
        column_name = pRecs->Fields->GetItem("COLUMN_NAME")->GetValue();
        data_type = pRecs->Fields->GetItem("DATA_TYPE")->GetValue();

        // output results
        m_piResponse->Write(_variant_t("<TR><TD>"));
        if (table_name != curr_table) {
            curr_table = table_name;
            m_piResponse->Write(table_name);
        }
        m_piResponse->Write(_variant_t("</TD><TD>"));
        m_piResponse->Write(column_name);
        m_piResponse->Write(_variant_t("</TD><TD>"));
        m_piResponse->Write(data_type);
        m_piResponse->Write(_variant_t("</TD></TR>"));
      
        pRecs->MoveNext();
    }
    m_piResponse->Write(_variant_t("</table>"));
    
    // close connection
    pRecs->Close();
    pConnection->Close();

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

	return S_OK;
}
