// container.h : Declaration of the Ccontainer

#ifndef __CONTAINER_H_
#define __CONTAINER_H_

#include "resource.h"       // main symbols

#include <comsvcs.h>
#include <asptlb.h>
#include <activeds.h>

/////////////////////////////////////////////////////////////////////////////
// Ccontainer
class ATL_NO_VTABLE Ccontainer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Ccontainer, &CLSID_container>,
	public IObjectControl,
	public IDispatchImpl<Icontainer, &IID_Icontainer, &LIBID_ASP1701Lib>
{
public:
	Ccontainer()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CONTAINER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Ccontainer)
	COM_INTERFACE_ENTRY(Icontainer)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// Icontainer
public:
	STDMETHOD(enumObjectsByFilter)(/*[in]*/ BSTR bstrFilter);
	STDMETHOD(showUsers)();
	STDMETHOD(enumObjects)(/*[in]*/ BSTR bstrContainer);
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

private:
 	CComPtr<IObjectContext> m_spObjectContext;
    CComPtr<IResponse>m_piResponse;
   
    };

#endif //__CONTAINER_H_
