VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "compobj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data wrapper that updates and queries Component table
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Wrapper methods


' create media obj
Sub createComponent(ByVal strName As String, _
                    ByVal strFile As String, _
                    ByVal strExt As String, _
                    ByVal strCompTypeCd As String, _
                    ByVal strCompLanguage As String, _
                    ByVal varSource As Variant, _
                    ByVal strSrcProject As String, _
                    ByVal varSrcDirectoryId As Variant, _
                    ByVal varPulledDate As Variant, _
                    ByVal varPurpose As Variant)

Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' possible null values
If Len(strSrcProject) = 0 Then
   strSrcProject = "null"
Else
   strSrcProject = "'" & strSrcProject & "'"
End If
If Len(varSrcDirectoryId) = 0 Then
   varHeight = "null"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)
strCompLanguage = Left(strCompLanguage, 20)
strSrcProject = Left(strSrcProject, 50)

' replace occurrances of single quote with double
varPurpose = Replace(varPurpose, "'", "''", , , vbTextCompare)

' build insert
Dim str As String
str = "insert into Component (name, filename, ext, comp_type_cd, " & _
           "comp_language, have_source, source_project, source_directory_id, " & _
           "pulled_date, purpose)" & _
           " values('" & strName & "','" & strFile & "','" & UCase(strExt) & _
           "','" & strCompTypeCd & "','" & strCompLanguage & "'," & varSource & "," & _
           strSrcProject & "," & varSrcDirectoryId & "," & varPulledDt & ",'" & _
           varPurpose & "')"
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Creating Component: " & Err.Description

End Sub



' update media object
Sub updateComponent(ByVal varComponentId As Variant, _
                    ByVal strName As String, _
                    ByVal strFile As String, _
                    ByVal strExt As String, _
                    ByVal strCompTypeCd As String, _
                    ByVal strCompLanguage As String, _
                    ByVal varSource As Variant, _
                    ByVal strSrcProject As String, _
                    ByVal varSrcDirectoryId As Variant, _
                    ByVal varPulledDate As Variant, _
                    ByVal varPurpose As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

' possible null values
If Len(strSrcProject) = 0 Then
   strSrcProject = "null"
Else
   strSrcProject = "'" & strSrcProject & "'"
End If
If Len(varSrcDirectoryId) = 0 Then
   varHeight = "null"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)
strCompLanguage = Left(strCompLanguage, 20)
strSrcProject = Left(strSrcProject, 50)

' replace occurrances of single quote with double
varPurpose = Replace(varPurpose, "'", "''", , , vbTextCompare)

' create command
Dim comnd As New Command
Set comnd.ActiveConnection = cn
comnd.CommandType = adCmdText

' build update
Dim str As String
str = "update Component set " _
      & "name = '" & strName & "', " _
      & "filename = '" & strFile & "', " _
      & "ext = '" & UCase(strExt) & "', " _
      & "comp_type_cd = '" & strCompTypeCd & "', " _
      & "comp_language = '" & strCompLanguage & "', " _
      & "have_source = " & varSource & ", " _
      & "source_project = " & strSrcProject & ", " _
      & "source_directory_id = " & varSrcDirectoryId & ", " _
      & "pulled_date = " & varPulledDt & ", " _
      & "purpose = '" & varPurpose & "'" _
      & " where id = " & CStr(varComponentId)
      
comnd.CommandText = str

comnd.Execute

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Updating Component: " & Err.Description

End Sub




' delete specific media obj
Sub deleteComponent(ByVal varComponentId As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' build deletion
Dim str As String
str = "delete from Component where id = " & CStr(varComponentId)
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Media Object: " & Err.Description

End Sub


' return partial records for all media objects
Function getPartialComponents() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

rs.CursorLocation = adUseClient

' query for directories
Dim str As String
str = "select a.id, a.name, filename, source_project, b.name " & _
      "from Component a, Directory b where source_directory_id = b.id " & _
      " order by 4, 2"
rs.Open str, cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getPartialComponents = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Partial Components: " & Err.Description

End Function


' return specific item
Function getComponent(ByVal varComponentId As Variant) As ADODB.Recordset

Dim cn As New Connection
Dim rs As New Recordset
Dim errstr As String

On Error GoTo ErrorHandler

' open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' query for component
 Set rs.ActiveConnection = cn

' run query
Dim str As String
rs.Source = "select * from Component where id = " & CStr(varComponentId)
rs.Open

' disconnect recordset
Set rs.ActiveConnection = Nothing
cn.Close

Set getComponent = rs
Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, errstr & "Retrieving MediaObject: " & Err.Description

End Function




