VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "directory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data wrapper that updates and queries Dictionary table
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
m_connString = "Provider=SQLOLEDB;server=FLAME\MARVIN;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
'm_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Wrapper methods


' create directory
Sub createDirectory(ByVal strName As String, ByVal strLoc As String, _
                     ByVal strWebLoc As String, ByVal strPurpose As String)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' possible null value for purpose
If Len(strWebLoc) = 0 Then
   strWebLoc = "null"
Else
   strWebLoc = "'" & Left(strWebLoc, 50) & "'"
End If

' truncate strings if necessary
strName = UCase(Left(strName, 50))
strLoc = Left(strLoc, 50)
strPurpose = Left(strPurpose, 50)

' build insert
Dim str As String
str = "insert into Directory (name, physical_location, web_location, purpose)" & _
           " values('" & strName & "','" & strLoc & "'," & strWebLoc & _
           ",'" & strPurpose & "')"
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Creating Directory: " & Err.Description

End Sub



' create directory
Sub updateDirectory(ByVal iDirectoryId As Integer, _
                     ByVal strName As String, ByVal strLoc As String, _
                     ByVal strWebLoc As String, ByVal strPurpose As String)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

' possible null value for purpose
If Len(strWebLoc) = 0 Then
   strWebLoc = "null"
Else
   strWebLoc = "'" & Left(strWebLoc, 50) & "'"
End If

' create command
Dim comnd As New Command
Set comnd.ActiveConnection = cn
comnd.CommandType = adCmdText

' truncate strings if necessary
strName = UCase(Left(strName, 50))
strLoc = Left(strLoc, 50)
strPurpose = Left(strPurpose, 50)

' build update
Dim str As String
str = "update directory set " _
      & "name = '" & strName & "', " _
      & "physical_location = '" & strLoc & "', " _
      & "web_location = " & strWebLoc & ", " _
      & " purpose = '" & strPurpose & "' " _
      & "where id = " & CStr(iDirectoryId)
      
comnd.CommandText = str

comnd.Execute

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Updating Directory: " & Err.Description

End Sub




' delete specific directory
Sub deleteDirectory(ByVal iDictionaryId As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' build deletion
Dim str As String
str = "delete from Directory where id = " & CStr(iDictionaryId)
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Directory: " & Err.Description

End Sub

' return all directories
Function getDirectories() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

' query for directories
rs.Open "select * from Directory order by name", cn, _
        adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getDirectories = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Directories: " & Err.Description

End Function


' return all directories
Function getPartialDirectories() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

rs.CursorLocation = adUseClient

' query for directories
rs.Open "select id, name from Directory order by name", _
        cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getPartialDirectories = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Partial Directories: " & Err.Description

End Function


' return specific Directory item
Function getDirectory(ByVal iDirectoryId As Variant) As ADODB.Recordset

Dim cn As New Connection
Dim rs As New Recordset
Dim errstr As String

On Error GoTo ErrorHandler

' open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' query for directories
 Set rs.ActiveConnection = cn

' run query
Dim str As String
rs.Source = "select * from Directory where id = " & CStr(iDirectoryId)
rs.Open

' disconnect recordset
Set rs.ActiveConnection = Nothing
cn.Close

Set getDirectory = rs
Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, errstr & "Retrieving Directory: " & Err.Description

End Function
