VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "user"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' create a new user in Active Directory
Sub createUser(ByVal strFirstname As String, _
                ByVal strLastname As String, _
                ByVal strLogin As String, _
                ByVal strCompany As String, _
                ByVal strTitle As String, _
                ByVal strPhone As String)
                
                
On Error GoTo ErrorHandler

   Dim iUsers As IADsContainer
   Dim iUser As IADsUser

   ' get container
   Set iUsers = GetObject("LDAP://CN=Users,DC=development,DC=local")

   ' modify name to relative name
   Dim strRelative As String
   strRelative = "CN=" & strFirstname & " " & strLastname

   ' create user object
   Set iUser = iUsers.Create("user", strRelative)

   ' modify properties
   iUser.Put "cn", strFirstname & " " & strLastname
   iUser.Put "sAMAccountName", strLogin
   iUser.FirstName = strFirstname
   iUser.LastName = strLastname
   
   ' possible null values
   If Len(strCompany) > 0 Then
      iUser.Put "company", strCompany
   End If
   If Len(strTitle) > 0 Then
      iUser.Title = strTitle
   End If
   If Len(strPhone) > 0 Then
      iUser.TelephoneNumber = strPhone
   End If

   ' save to directory service
   iUser.SetInfo

Exit Sub
ErrorHandler:

   Err.Raise Err.Number, Err.Source, strPhone & "Creating User: " & Err.Description

End Sub

' remove specific user
Sub removeUser(ByVal strName As String)

On Error GoTo ErrorHandler

   Dim iUsers As IADsContainer
   Dim iUser As IADsUser

   ' get container
   Set iUsers = GetObject("LDAP://CN=Users,DC=development,DC=local")

   ' modify name to relative name
   Dim strRelative As String
   strRelative = "CN=" & strName

   ' remove user
   iUsers.Delete "user", strRelative
   
Exit Sub
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Removing User: " & Err.Description

End Sub

' get user identified by CN
Function getUser(ByVal strCnName As String) As Recordset

On Error GoTo ErrorHandler

   ' connect to Active Directory
   Dim cn As New Connection
   cn.CursorLocation = adUseClient
   cn.Provider = "ADsDSOObject"
   cn.Open
      
   ' set recordset
   Dim rs As New Recordset
   Set rs.ActiveConnection = cn
   
   ' perform query
   Dim str As String
   str = "select cn, sAMAccountName, company, title, telephoneNumber " & _
      "from 'LDAP://CN=" & strCnName & ",CN=Users,DC=development, DC=local'"
   rs.Source = str
   rs.Open
   
   ' disconnect recordset
   Set rs.ActiveConnection = Nothing
   cn.Close
   
   ' return record
   Set getUser = rs
   
Exit Function
ErrorHandler:

   cn.Close
   Err.Raise Err.Number, Err.Source, str & Err.Description

End Function
